//////////////////////////////////////////////////////////////////////////////
//	A collection of RGB entries.
//////////////////////////////////////////////////////////////////////////////

#ifndef __COLORRGB_PALETTE
#define __COLORRGB_PALETTE

#include "inc/system.h"
// #include "ColorRGB.h"

// XXX MODIFIED FOR DREAMCAST, cColorRGB replaced with 2 BYTES (uint16)

class cColorRGBPalette : public vector<uint16>
{
	///////////////////////////////////////////////////////////////////////////
	//	METHODS
	///////////////////////////////////////////////////////////////////////////
public:
	cColorRGBPalette() {}				// Constructor
	virtual ~cColorRGBPalette() {}	// Destructor

	// Add color to palette.
	uint16& operator+= (uint16& color);

	// Return index position (1 based) of where color exists in palette.
	int getEntryPosition(uint16& color);
};

#endif // __COLORRGB_PALETTE
// vi:set ts=3:
