//////////////////////////////////////////////////////////////////////////////
//
//	zeldaEventIDs.h
//	Defines for the cEvent class.
//
// -	ID's for each event type present in the game.
//	-	Tabs set to 3 spaces.
// 
//////////////////////////////////////////////////////////////////////////////

#ifndef	__ZELDAEVENTIDS_H__
#define	__ZELDAEVENTIDS_H__

//////////////////////////////////////////////////////////////////////////////
//	Defines for types of events.
//////////////////////////////////////////////////////////////////////////////

enum eEVENT_TYPE
{
	EVENT_TYPE_UNDEFINED						=	-1,
	EVENT_TYPE_DIALOGUE						=	0x01,	// Screen-based dialogue event
	EVENT_TYPE_PORTAL_TELEPORT_INACTIVE =	0x08,	// Portal that automatically teleports Link to the destination
	EVENT_TYPE_PORTAL_TELEPORT_ACTIVE	=	0x09,	// Portal that automatically teleports Link to the destination
	EVENT_TYPE_PORTAL_WALK_INACTIVE		=	0x0A,	// Portal that Link "walks into", defaulting to inactive
	EVENT_TYPE_PORTAL_WALK_ACTIVE			=	0x0B,	// Portal that Link "walks into"
	// ???KWB -- Many more will be added later, I'm sure...
};

#endif // __ZELDAEVENTIDS_H__
