/* standard C++ headers.  
 * NO GAME SPECIFIC ONES HERE */

#ifndef __INC_SYSTEM_H
#define __INC_SYSTEM_H

#include <kos.h>
#include <pcx/pcx.h>
//#include <tga/tga.h>
//#include <png/png.h>

// evil KOS/stlport hack
typedef unsigned int wint_t;

#ifdef WIN32
#include <windows.h>
#endif

// hack for mingw32, for the GL header files
#ifndef WINAPI
#define WINAPI	__stdcall
#endif

#include <cstdio>					// Support for C-style file I/O.
#include <fstream>				// File writing support.
#include <cstring>				// C-style string support.

// C++ Standard Template Library headers
#include <map>					// STL <map> (collection of key/value pairs)
#include <vector>				// STL <vector> (collection with index)
#include <string>				// STL string support.
//#include <iostream>			// NOT FOR DREAMCAST
//#include <fstream>

#include <exception>			// STL base for try/catch/throw support.
//#include <stdexcept>

// NEEDED.  Do NOT mess with this.
using namespace std;

// OpenGL/SDL headers
#include <GL/gl.h>				// OpenGL defines
#include <GL/glu.h>				// OpenGL Glu defines
//#include <SDL/SDL.h>			// -NEW- SDL headers

#endif // __INC_SYSTEM_H
