//////////////////////////////////////////////////////////////////////////////
//
//	Window.cpp
//	Implementation of the cWindow class.
//
//	-	Based on Jeff Molofee's OpenGL basecode (http://nehe.gamedev.net)
//	-	Tabs set to 3 spaces.
//
//	EVIL HACK.  to mess with 640x480 etc.
//
//////////////////////////////////////////////////////////////////////////////

#include "window.h"

//////////////////////////////////////////////////////////////////////////////
//	CONSTRUCTOR
//////////////////////////////////////////////////////////////////////////////
cWindow::cWindow()
{
	// Set defaults...
	m_iWidth		= 512;			// make em big
	m_iHeight		= 448;
	//m_iWidth			= 256;		// make em small
	//m_iHeight		= 224;
	m_iBitsPerPixel= 32;
	m_bIsFullScreen= false;
}

//////////////////////////////////////////////////////////////////////////////
//	DESTRUCTOR
//////////////////////////////////////////////////////////////////////////////
cWindow::~cWindow()
{
}

//////////////////////////////////////////////////////////////////////////////
//
// Terminate The Application
//
//////////////////////////////////////////////////////////////////////////////
void cWindow::terminateApplication()
{
	//???DAC - exception handling needs to be here
	/*static SDL_Event Q;
	Q.type= SDL_QUIT;
	if (SDL_PushEvent(&Q) == -1) {
		fprintf(stderr, "SDL_QUIT event cant be pushed: %s\n", SDL_GetError() );
		exit(1);
	}*/
	// Dreamcast - ?? wtf do we do here?
	//exit(0);
	//g_isProgramLooping = false;
	glKosShutdown();
}

//////////////////////////////////////////////////////////////////////////////
//
// Toggle Fullscreen/Windowed
//
//////////////////////////////////////////////////////////////////////////////
void cWindow::toggleFullscreen()
{
	//???DAC - exception handling!!
	/*SDL_Surface *S;
	S = SDL_GetVideoSurface();

	if (!S || (SDL_WM_ToggleFullScreen(S)!=1)) {
		fprintf(stderr, "Unable to toggle fullscreen: %s\n", SDL_GetError() );
	}*/
	// Dreamcast n/a
}


//////////////////////////////////////////////////////////////////////////////
//
// Reshape the OpenGL canvas when it's moved Or resized.
//
//	ARGS:	iWidth,	Width of the window to reshape.
//			iHeight,	Height of the window to reshape.
//
//////////////////////////////////////////////////////////////////////////////
void cWindow::reshapeGL(int iWidth, int iHeight)									
{
	// Reset the viewport.
	// XXX replace with the real numbers (0,0) for PC
	// 30,30 centers it for DC
	glViewport(30, 30, iWidth, iHeight);

	// Reset the OpenGL projection matrix.
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();

	// Reset the OpenGL modelview matrix (0,0 is bottom-left).
	glOrtho(0,256,0,224,-10,10);
	//glOrtho(-60,256,-30,224,-10,10);
	glMatrixMode (GL_MODELVIEW);
	glLoadIdentity();
}

//////////////////////////////////////////////////////////////////////////////
//
// Change the screen resolution.
//
//	ARGS:	iWidth,			Width of the window to reshape.
//			iHeight,			Height of the window to reshape.
//
//	RETURNS:	true,		on success resolution change.
//				false,	on failure.
//
//////////////////////////////////////////////////////////////////////////////
bool cWindow::changeScreenResolution(int iWidth,int iHeight,int iBitsPerPixel)
{
	// ???DAC - How do we do this in SDL?

	return true;
}

//////////////////////////////////////////////////////////////////////////////
//
// -	Creates a Win32 Window, and an OpenGL canvas.  Ties the two together.
//	-	Zero's structures program structures.
//
//	RETURNS:	true,		On successful window creation.
//				false,	On failure (assumes another function check's members
//							and cleans up appropriately.)
//
//////////////////////////////////////////////////////////////////////////////
bool cWindow::createWindowGL()
{
	// XXX SDL STUFF GOES HERE FOR NON-DC
		
	printf(">> starting gl!\n");
	
	if (glKosInit() == -1) {
		printf(">> glKosInit() BIG ERROR - no lists!\n");
	}

	// should be enabled??
	// not window stuff
	//glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_FILTER, GL_FILTER_BILINEAR);
    //glTexEnvi(GL_TEXTURE_2D, GL_TEXTURE_ENV_MODE, GL_MODULATEALPHA);
	
	//glEnable(GL_TEXTURE_2D);
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);

	// Resize the OpenGL canvas.
	reshapeGL(m_iWidth, m_iHeight);

	return true;
}

//////////////////////////////////////////////////////////////////////////////
// Destroy The OpenGL Window & Release Resources
//////////////////////////////////////////////////////////////////////////////
void cWindow::destroyWindowGL()
{
	// If window is in fullscreen mode, switch back.
	if (m_bIsFullScreen) {
		// XXX FIXME
	}
}
// vi:set ts=3:
