//////////////////////////////////////////////////////////////////////////////
//	A collection of RGB entries.
//////////////////////////////////////////////////////////////////////////////

#include "ColorRGBPalette.h"

// Add color to palette.
uint16& cColorRGBPalette::operator+= (uint16& color)
{ 
	push_back(color); return color;
}

// Return index position (1 based) of where color exists in palette.
int cColorRGBPalette::getEntryPosition(uint16& color)
{
	for (int i=0; i < size(); i++) {
		if (color == this->operator[](i)) {
			return i+1;						// Make 1 based since 0 means no match.
		}
	}
	return 0;
}
// vi:set ts=3:
