//////////////////////////////////////////////////////////////////////////////
//
//	OBJECTInventoryItem.cpp
//	Implementation for the cObjectInventoryItem class.
//
//	-	Encapsulation for "shot" types (sword, enemy fire, etc...)
//	-	Tabs set to 3 spaces.
// 
//////////////////////////////////////////////////////////////////////////////


#include "objectInventoryItem.h"

//////////////////////////////////////////////////////////////////////////////
//
//	CONSTRUCTOR
//
//	ARGS:	pGameState,		Point to game state object.
//			oSpriteData,	Contains data on how to construct sprite.
//
//////////////////////////////////////////////////////////////////////////////
cObjectInventoryItem::cObjectInventoryItem(cGameState* pGameState, cSpriteData& oSpriteData) :	
	cSprite(pGameState, oSpriteData)
{
}

//////////////////////////////////////////////////////////////////////////////
// DECONSTRUCTOR
//////////////////////////////////////////////////////////////////////////////
cObjectInventoryItem::~cObjectInventoryItem()
{
}

//////////////////////////////////////////////////////////////////////////////
//
//	Activate this Inventory Item
//
//	ARGS:
//		fx - x coordinate of activation
//		fy - y coordinate of activation
//		eDirection - direction of action
//
//	POST:
//		Item is "activated", it decides for itself what to do.
//
//	RETURN:
//		bool indicating whether link should be shown in his action pose
//			while activating.
bool cObjectInventoryItem::activate(float fx, float fy, eDIRECTION eDirection)
{
	return false;
}


void cObjectInventoryItem::reset(float fx, float fy)
{
}

void cObjectInventoryItem::reset()
{
}
// vi:set ts=3:
