//////////////////////////////////////////////////////////////////////////////
//
//	OBJECTprojectileMagic.h
//	Defines for the cObjectProjectileMagic class.
//
//	-	Tabs set to 3 spaces.
// 
//////////////////////////////////////////////////////////////////////////////

#ifndef __OBJECTPROJECTILEMAGIC_H__
#define __OBJECTPROJECTILEMAGIC_H__

#include "gameState.h"
#include "tiles.h"
#include "GameException.h"
#include "gameState.h"
#include "objectInventoryItem.h"

class cObjectProjectileMagic : public cObjectInventoryItem
{
	///////////////////////////////////////////////////////////////////////////
	//	METHODS
	///////////////////////////////////////////////////////////////////////////
protected:
	cObjectProjectileMagic();	// Default constructor non-creatable.

public:
	cObjectProjectileMagic(cGameState* pGameState);
	virtual ~cObjectProjectileMagic();

	// Implementation of cSprite virtuals...
	bool collide(cSprite* pSprite);
	void reset();	
	void update();
	void draw();
	void flash();

	eHIT_TYPE getHitType() { return HIT_TYPE_MAGIC; }

	// Overload of reset to move projectile while in swing.
	void reset(float fx, float fy);

	// Start a swinging of the projectile.
	bool activate(float fx, float fy, eDIRECTION eDirection);
};

#endif // __OBJECTPROJECTILEMAGIC_H__
// vi:set ts=3:
