//////////////////////////////////////////////////////////////////////////////
//
//	OBJECTprojectileSword.h
//	Defines for the cObjectProjectileSword class.
//
//	-	Tabs set to 3 spaces.
// 
//////////////////////////////////////////////////////////////////////////////

#ifndef __OBJECTPROJECTILESWORD_H__
#define __OBJECTPROJECTILESWORD_H__

#include "gameState.h"
#include "tiles.h"
#include "GameException.h"

#include "gameState.h"
#include "objectInventoryItem.h"

class cObjectProjectileSword : public cObjectInventoryItem
{
	///////////////////////////////////////////////////////////////////////////
	//	METHODS
	///////////////////////////////////////////////////////////////////////////
protected:
	cObjectProjectileSword();	// Default constructor non-creatable.

public:
	cObjectProjectileSword(cGameState* pGameState);
	virtual ~cObjectProjectileSword();

	// Implementation of cSprite virtuals...
	bool collide(cSprite* pSprite);
	void reset();	
	void update();
	void draw();
	void flash();

	eHIT_TYPE getHitType() { return HIT_TYPE_SWORD; }

	// Overload of reset to move sword while in swing.
	void reset(float fx, float fy);

	// Start a swinging of the sword.
	bool activate(float fx, float fy, eDIRECTION eDirection);
};

#endif // __OBJECTPROJECTILESWORD_H__
// vi:set ts=3:
