//////////////////////////////////////////////////////////////////////////////
//
//	OBJECTShot.h
//	Defines for the cObjectShot class.
//
//	-	Tabs set to 3 spaces.
// 
//////////////////////////////////////////////////////////////////////////////

#ifndef __OBJECTSHOT_H__
#define __OBJECTSHOT_H__

#include "inc/system.h"

#include "sprite.h"			// Support for sprites.
#include "gameState.h"		// Support for the game state object.
#include "GameException.h"

class cObjectShot : public cSprite  
{
	///////////////////////////////////////////////////////////////////////////
	//	MEMBERS
	///////////////////////////////////////////////////////////////////////////


	///////////////////////////////////////////////////////////////////////////
	//	METHODS
	///////////////////////////////////////////////////////////////////////////
protected:
	cObjectShot(){}	//	Default constructor non-creatable

public:
	cObjectShot(cGameState* pGameState, cSpriteData& oSpriteData);
	virtual ~cObjectShot();

	// Implementation of cSprite (pure) virtuals...
	void reset();
	void update(float fFrameFactor);
	void draw();

};

#endif // __OBJECTSHOT_H__
// vi:set ts=3:
