//////////////////////////////////////////////////////////////////////////////
//
//	OBJECTSparkle.h
//	Defines for the cObjectSparkleclass.
//
//	-	Handles sparkles and creation of bounty after enemy dies.
//	-	Tabs set to 3 spaces.
// 
//////////////////////////////////////////////////////////////////////////////

#ifndef __OBJECTSPARKLE_H__
#define __OBJECTSPARKLE_H__

#include "gameState.h"
#include "tiles.h"
#include "GameException.h"
#include "sprite.h"			// Support for sprites.
#include "gameState.h"		// Support for the game state object.


class cObjectSparkle : public cSprite  
{
	///////////////////////////////////////////////////////////////////////////
	//	MEMBERS
	///////////////////////////////////////////////////////////////////////////
private:
	eGOODIES m_eGoodie;	// Type of item(s) could appear when sparkle ends.


	///////////////////////////////////////////////////////////////////////////
	//	METHODS
	///////////////////////////////////////////////////////////////////////////
private:
	cObjectSparkle(){}		//	Default constructor non-creatable
	cObjectSparkle(cGameState*, cSpriteData&){}

public:
	cObjectSparkle(cGameState* pGameState, float fx, float fy, eGOODIES eGoodie);
	virtual ~cObjectSparkle();

	void update();
	void draw();

};

#endif // __OBJECTSPARKLE_H__
// vi:set ts=3:
